Package org.zkoss.stateless.sul

## Interface IOrganigram

- All Superinterfaces:
    `IAnyGroup<IOrganigram>`, `IChildable<IOrganigram,​IOrgchildren>`, `IComponent<IOrganigram>`, `IHtmlBasedComponent<IOrganigram>`, `IXulElement<IOrganigram>`

      public interface IOrganigram
      extends IXulElement<IOrganigram>, IChildable<IOrganigram,​IOrgchildren>, IAnyGroup<IOrganigram>

  Immutable `Organigram` component

  A container which can be used to draw a hierarchical organizational chart, you can specify a `TreeModel` to render the data.

  ### Support @Action

  Name | Action Type
  --- | ---
  onSelect | ActionData: `SelectData` Notifies one that the user has selected a new item in the organigram.

  To retrieve what is selected in Organigram with a `TreeSelectableModel`, you shall use `TreeSelectableModel.isPathSelected(int[])` to check whether the current path is selected in `TreeSelectableModel`. That is, you shall operate on the item of the `TreeSelectableModel` rather than on the `IOrgitem` of the `IOrganigram` if you use the `TreeSelectableModel` and `TreeModel`.

  To retrieve what are opened nodes in Organigram with a `TreeOpenableModel`, you shall use `TreeOpenableModel.isPathOpened(int[])` to check whether the current path is opened in `TreeOpenableModel` rather than using `IOrgitem.isOpen()`. That is, you shall operate on the item of the `TreeOpenableModel` rather than on the `IOrgitem` of the `IOrganigram` if you use the `TreeOpenableModel` and `TreeModel`.

  Author:
    katherine
  See Also:
    `Organigram`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IOrganigram.Builder` | Builds instances of type `IOrganigram`.
    `static class` | `IOrganigram.Updater` | Builds an updater of type `IOrganigram` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IOrganigram` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IOrganigram` | `of​(java.lang.Iterable<? extends IOrgchildren> children)` | Returns the instance with the given `IOrgchildren` children.
    `static IOrganigram` | `of​(IOrgchildren... children)` | Returns the instance with the given `IOrgchildren` children.
    `static IOrganigram` | `ofId​(java.lang.String id)` | Returns the instance with the given id.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IOrganigram DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.layout.Organigram"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IOrganigram>`
      Returns:

    - #### of

          static IOrganigram of​(java.lang.Iterable<? extends IOrgchildren> children)

      Returns the instance with the given `IOrgchildren` children.
      Parameters:
        `children` - The children of `IOrgchildren`

    - #### of

          static IOrganigram of​(IOrgchildren... children)

      Returns the instance with the given `IOrgchildren` children.
      Parameters:
        `children` - The children of `IOrgchildren`

    - #### ofId

          static IOrganigram ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component